var _createClass = function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};}();function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}var WorkList = function () {
    /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    * @param {object} options
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    */
    function WorkList(options) {_classCallCheck(this, WorkList);
        var _defaults = {
            workItem: '.js-work-item',
            workItemPreviewList: '.js-work-preview-list',
            workItemImg: '.js-work-preview',

            //
            activeItemClass: 'is-active',

            //
            workCanvas: '.js-work-preview-canvas' };


        this.defaults = Object.assign({}, _defaults, options);

        if (this.getWorkItem().length > 0) {
            this.init();
            this.workItemHover(this.getWorkItem());
            this.workHover(this.getWorkItemPreviewList());
            this.initWorkCanvas();
        }
    }

    // region Getters

    /**
     *
     * @returns {*|jQuery|HTMLElement}
     */_createClass(WorkList, [{ key: 'getWorkItem', value: function getWorkItem()
        {
            return $(this.defaults.workItem);
        } }, { key: 'getWorkItemImg', value: function getWorkItemImg()

        {
            return $(this.defaults.workItemImg);
        } }, { key: 'getWorkItemPreviewList', value: function getWorkItemPreviewList()

        {
            return $(this.defaults.workItemPreviewList);
        } }, { key: 'getWorkCanvas', value: function getWorkCanvas()

        {
            return $(this.defaults.workCanvas);
        } }, { key: 'getCanvasEl', value: function getCanvasEl()

        {
            return $(this.defaults.workCanvas).find('canvas');
        }

        // endregion
    }, { key: 'init', value: function init()
        {
            console.log('WorkList init()');
        }

        /**
           *
           * @param workItem
           */ }, { key: 'workItemHover', value: function workItemHover(
        workItem) {var _this = this;
            workItem.on('mouseenter', function (e) {
                e.preventDefault();

                var workItemId = $(e.currentTarget).data('work-preview-id');

                _this.workHoverEnter(workItemId);
            });

            workItem.on('mouseleave', function () {
                _this.workHoverLeave();
            });
        }

        /**
           *
           * @param workContainer
           */ }, { key: 'workHover', value: function workHover(
        workContainer) {
            $(document).on('mousemove', function (ev) {
                var decimalX = ev.clientX / window.innerWidth - 0.5;
                var decimalY = ev.clientY / window.innerHeight - 0.5;

                TweenMax.to(workContainer, 0.4, {
                    x: 180 * decimalX,
                    y: 90 * decimalY,
                    ease: Power3.easeOut });

            });

            // SETTINGS
            var workItem = $(this.defaults.workItem);
            var hoverDuration = 0.4;
            var opacityLevel = 0.3;


            // CONTEXT SHIFTING
            // mouseenter
            $(document).on('mouseenter', this.defaults.workItem, function (ev) {
                ev.preventDefault();

                var notItem = workItem.not(ev.currentTarget);

                TweenMax.to(ev.currentTarget, hoverDuration, {
                    opacity: 1,
                    ease: Power3.easeOut });


                TweenMax.to(notItem, hoverDuration, {
                    opacity: opacityLevel,
                    x: 0,
                    ease: Power3.easeOut });

            });

            // mouseleave
            $(document).on('mouseleave', this.defaults.workItem, function (ev) {
                ev.preventDefault();

                var notItem = workItem.not(ev.currentTarget);

                TweenMax.to([ev.currentTarget, notItem], hoverDuration, {
                    opacity: 1,
                    ease: Power3.easeOut });

            });
        } }, { key: 'initWorkCanvas', value: function initWorkCanvas()

        {
            // CANVAS DIMENSIONS
            var canvasWidth = this.getWorkItemImg().innerWidth();
            var canvasHeight = this.getWorkItemImg().innerHeight();

            // CREATE PIXI APPLICATION
            var app = new PIXI.Application(
            canvasWidth,
            canvasHeight, {
                transparent: true });



            // APPEND CANVAS
            this.getWorkCanvas().append(app.view);

            // CREATE SLIDES CONTAINER
            this.slidesContainer = new PIXI.Container();
            app.stage.addChild(this.slidesContainer);

            // CREATE DISPLACEMENT MAP
            //const displacementMap = PIXI.Sprite.fromImage(this.getWorkCanvas().data('displacement-map'));

            var displacementMap = PIXI.Sprite.fromImage(this.getWorkCanvas().css('background-image').replace(/.*\s?url\([\'\"]?/, '').replace(/[\'\"]?\).*/, ''));

            // CREATE FILTER
            var filter = new PIXI.filters.DisplacementFilter(displacementMap);

            displacementMap.name = 'displacementMap';
            displacementMap.anchor.set(0.5);
            displacementMap.scale.set(1);
            displacementMap.position.set(canvasWidth / 2, canvasHeight / 2);

            app.stage.filterArea = app.screen;
            app.stage.filters = [filter];
            app.stage.addChild(displacementMap);

            // PIXI SPRITE ARRAY
            var _iteratorNormalCompletion = true;var _didIteratorError = false;var _iteratorError = undefined;try {for (var _iterator = this.getWorkItemImg()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {var spriteImage = _step.value;
                    //const texture = new PIXI.Texture.fromImage($(spriteImage).data('work-preview'));
                    var texture = new PIXI.Texture.fromImage($(spriteImage).css('background-image').replace(/.*\s?url\([\'\"]?/, '').replace(/[\'\"]?\).*/, ''));

                    var image = new PIXI.Sprite(texture);

                    image.name = 'workPreview';
                    image.alpha = 0;
                    image.width = canvasWidth;
                    image.height = canvasHeight;

                    this.slidesContainer.addChild(image);
                }

                // DISPLACE TIMELINE
            } catch (err) {_didIteratorError = true;_iteratorError = err;} finally {try {if (!_iteratorNormalCompletion && _iterator.return) {_iterator.return();}} finally {if (_didIteratorError) {throw _iteratorError;}}}this.displaceTl = new TimelineMax({
                paused: true });


            this.displaceTl.add('start').
            fromTo(this.getCanvasEl(), 0.4, {
                autoAlpha: 0 },
            {
                autoAlpha: 1,
                ease: Power4.easeOut },
            "start").
            fromTo(this.getCanvasEl(), 0.8, {
                scale: 1.25 },
            {
                scale: 1,
                ease: Power4.easeOut },
            "start").
            fromTo(
            filter.scale, 1.6, {
                x: 25,
                y: 75 },

            {
                x: 0,
                y: 0,
                ease: Power4.easeOut,
                onComplete: function onComplete() {

                } },
            "start");


            return [this.slidesContainer, this.displaceTl];
        } }, { key: 'workHoverEnter', value: function workHoverEnter(

        layerId) {var _this2 = this;
            // SET ALPHA OF HOVERED CASE PREVIEW
            TweenMax.to(this.slidesContainer.children[layerId], 0.4, {
                alpha: 1,
                ease: Power3.easeOut,
                onStart: function onStart() {
                    _this2.displaceTl.progress(0);
                    _this2.displaceTl.play();
                } });

        } }, { key: 'workHoverLeave', value: function workHoverLeave()

        {
            TweenMax.to(this.slidesContainer.children, 0.4, {
                alpha: 0,
                ease: Power3.easeOut });

        } }]);return WorkList;}();



new WorkList();